<template>
  <form class="modal fullscreen row justify-center items-center bg-light z-absolute" @submit.prevent>
    <div class="col-5 gt-sm">
      <img src="~assets/login_image.jpg" alt="" style="max-height: 100%; max-width: 100%" />
    </div>
    <div class="col col-sm-10 col-md-7 layout-padding">
      <q-card flat>
        <q-card-title>
          <div class="q-display-1">Sign in to iRewind</div>
        </q-card-title>
        <q-card-main>
          <div>
            <q-btn type="button" size="2rem" class="no-min-height q-pa-none q-my-none q-mr-md" color="blue-10" flat icon="fab fa-facebook-square" @click="loginFacebook" />
            <q-btn type="button" size="2rem" class="no-min-height q-pa-none q-my-none" color="deep-orange-10" flat icon="fab fa-google-plus-square" @click="loginGoogle" />
          </div>
          <div class="q-my-md">
            <div class="q-title">Or</div>
          </div>
          <q-field :error="$v.form.username.$error">
            <q-input color="white" inverted-light required autocomplete="username" autocapitalize="off"
              autofocus
              name="username"
              v-model="form.username"
              @input="$v.form.username.$touch"
              float-label="Email or Username"
            />
          </q-field>
          <q-field :error="$v.form.password.$error" class="q-mt-md">
            <q-input color="white" inverted-light required autocomplete="current-password" autocapitalize="off" type="password"
              name="password"
              v-model="form.password"
              @input="$v.form.password.$touch"
              float-label="Password"
            />
          </q-field>
          <div v-if="message" class="q-my-md text-negative" v-html="message" />
          <div class="q-pt-md row justify-between">
            <q-btn no-caps class="q-px-xl q-py-lg" color="primary" :loading="processing" type="submit" label="Authenticate" :disable="$v.form.$error" @click="submitForm" />
            <q-btn no-caps class="q-px-xl q-py-lg" color="faded" flat type="reset" :tabindex="-1" label="Clear" v-if="!credentials.token && !cancellable" @click="clearForm" />
            <q-btn no-caps class="q-px-xl q-py-lg" color="faded" flat :tabindex="-1" label="Cancel" v-if="credentials.token || cancellable" @click="cancelForm" />
          </div>
        </q-card-main>
      </q-card>
    </div>
  </form>
</template>

<script>
  import { mapActions, mapState } from 'vuex';
  import { required } from 'vuelidate/lib/validators';
  import { showRejectionMessage } from '../../utils';
  import { facebookAppId, googleAppId, authRedirectUrl } from '../../config';

  const emptyForm = {
    username: '',
    password: '',
  };

  export default {
    name: 'irwAuth',
    data() {
      return {
        form: { ...emptyForm },
        processing: false,
      };
    },
    validations: {
      form: {
        username: {
          required,
        },
        password: {
          required,
        },
      },
    },
    computed: {
      ...mapState('auth', [
        'credentials',
        'cancellable',
        'message',
      ]),
    },
    methods: {
      ...mapActions('auth', [
        'login',
        'clear',
        'cancel',
      ]),
      cancelForm() {
        this.$router.go(-1);
        this.cancel();
      },
      clearForm() {
        this.form = { ...emptyForm };
        this.$v.form.$reset();
        this.clear();
      },
      submitForm() {
        this.processing = true;
        this.$v.form.$touch();
        if (this.$v.form.$error) {
          this.processing = false;
          return;
        }
        this
          .login(this.form)
          .then((value) => {
            this.processing = false;
            this.$q.notify({
              type: 'positive',
              message: 'Successfully authenticated',
              position: 'bottom-right',
            });
            return value;
          })
          .catch((rejection) => {
            this.processing = false;
            if (rejection.response) {
              showRejectionMessage(rejection, 'Invalid credentials');
            }
          });
      },
      loginFacebook() {
        const url = window.location.toString();
        const redirect = [
          'https://www.facebook.com/dialog/oauth',
          `?client_id=${ facebookAppId }`,
          '&response_type=token',
          '&scope=public_profile,email',
          `&state=facebook${ encodeURIComponent(url) }`,
          `&redirect_uri=${ encodeURIComponent(authRedirectUrl) }`,
        ].join('');
        window.location = redirect;
      },
      loginGoogle() {
        const url = window.location.toString();
        const redirect = [
          'https://accounts.google.com/o/oauth2/v2/auth',
          `?client_id=${ googleAppId }`,
          '&response_type=token',
          '&scope=profile%20email',
          '&prompt=select_account',
          '&include_granted_scopes=true',
          `&state=google${ encodeURIComponent(url) }`,
          `&redirect_uri=${ encodeURIComponent(authRedirectUrl) }`,
        ].join('');
        window.location = redirect;
      },
    },
    mounted() {
      this.form = {
        ...emptyForm,
        username: this.credentials.username || '',
        password: this.credentials.password || '',
      };
      if (this.form.username && this.form.password) {
        this.submitForm();
      }
    },
  };
</script>
